/**
 * @file   int_stack.h
 * @author David Bremner <bremner@unb.ca>
 * @date   Mon Mar 25 21:41:09 2002
 * 
 * @brief  stacks of integers
 * 
 * 
 */
#ifndef _INT_STACK_H
#define _INT_STACK_H

#include "primtypes.h"
#include "nalloc.h"

typedef struct is_struct {
  natural_t	size;
  natural_t	top;
  int		elem[1];	/**< Variable size */
} int_stack_t, *int_stack_p;

extern int istack_top(int_stack_p);
extern int_stack_p istack_new(natural_t);
extern int istack_empty(int_stack_p);
extern int istack_count(int_stack_p);
extern int istack_full(int_stack_p);
extern int istack_pop(int_stack_p);
extern void istack_destroy(int_stack_p);
extern void istack_flush(int_stack_p);
extern void istack_push(int_stack_p, int);
extern na_node_p istack_nalloc(na_node_p, slot_t, natural_t);


#endif
